/*
 * BL_TB_ActiveBtn.java
 * Created on 2. Dezember 2007, 18:44
 * BorderLiner Toolbar Active Button
 */

package name.dhiller.jBorderLiner;

import com.sun.star.frame.FeatureStateEvent;
import com.sun.star.beans.NamedValue;
//import com.sun.star.util.URL;
import java.text.DecimalFormat;
//import com.sun.star.util.XURLTransformer;

/**
 * @author dhiller
 * @version 080116
 */
class BL_TB_LSPreviewBtn extends BL_ToolbarItem {
    static String m_sImageDir;
    static boolean active;
    
    /** Creates a new instance of BL_TB_ActiveBtn */
    BL_TB_LSPreviewBtn() {
        super();
    }
    
    /** init - Initialize Linestyle preview
     */
    void Init(com.sun.star.frame.XFrame xFrame,
              com.sun.star.frame.XStatusListener xControl,
              com.sun.star.util.URL aURL, String sImageDir) {
        super.Init (xFrame, xControl, aURL, null);
        m_sImageDir = sImageDir;
        FeatureStateEvent aState = new FeatureStateEvent();
        aState.FeatureURL = aURL;
        aState.IsEnabled  = true;
        active  = false;
        aState.State      = active;
        xControl.statusChanged(aState);
    }
    
    /* dispatch - there is something to do
     * @param this aURL - this URL
     * @param aArguments (Name="Linestyle", Value=Style#)
     */
    void dispatch( com.sun.star.util.URL aURL,
                   com.sun.star.beans.PropertyValue[] aArguments )
    {
        int i;
        for (i=0; i < aArguments.length; i++) {
            if (aArguments[i].Name.equals("Linestyle")) {
                setLinestyle( ((Integer)(aArguments[i].Value)).intValue() );
                //drawLineStyle(aArguments);
                break;
            }
        }
    }

    /** draws the image 
     * @see BLRegistry
     * @param aArguments Value[0] contains number of linestyle
     */
 /*   void drawLineStyle( com.sun.star.beans.PropertyValue[] aArguments ) {
        NamedValue asTemplate = new NamedValue();
        NamedValue[] loadArgs = new NamedValue[1];

        DecimalFormat df = new DecimalFormat("00");
        asTemplate.Name = new String("URL");
        asTemplate.Value = m_sImageDir+"LS"+df.format(aArguments[0].Value)+".png";
        loadArgs[0] = asTemplate;
        
        SendCommandTo(xTBControl, new String("SetImage"), loadArgs);
    }*/
     
    /**
     * sets the preview according to the current line style
     * @param icurrentLinestyle - number of linestyle
     */
    void setLinestyle(int icurrentLinestyle) {
        NamedValue asTemplate = new NamedValue();
        NamedValue[] loadArgs = new NamedValue[1];

        DecimalFormat df = new DecimalFormat("00");
        asTemplate.Name = new String("URL");
        asTemplate.Value = m_sImageDir+"LS"+df.format(icurrentLinestyle)+".png";
        loadArgs[0] = asTemplate;

        sendCommandToAll("SetImage", loadArgs);
    }
}